;; ncat.star - concatenate N strings

	radix 0x10
	header 	`x'


;;
;; In:
;;	string1 string2 string3 ... stringN N.real
;;
;; Out:
;;	string1+string2+string3+...stringN
;;

	rpl
	  Prg
	    Need_N_args
	endrpl

; Check N arguments, returning:
;
; If all N arguments are strings:
;	2: size.nybbles
;	1: @#False
;
; If bad arguments:
;	1: @#True

	code

	call	save_regs	; Save away RPL regs
	call	getshort	; A.A = N.short
	dec.a	a
	brcs	$777		; N == 0 ; error
	move.p5	type_string, c
	move.a	c, d		; D.A = string type prefix
	clr.a	b		; Use to sum up sizes
$100:
	move.a	@d1, c
	add	5, d1
	move	c, d0		; D0 = &arg
	move.a	@d0, c
	brne.a	d, c, $777	; Arg is not string ; error
	add	5, d0
	move.a	@d0, c		; C.A = size + 5
	sub.a	5, c		; C.A = size
	add.a	c, b		; B.A += arg string size
	brcs	$777

	dec.a	a		; One arg less to go
	brcc	$100		; Loop

	move.a	b, c
	move	c, r0
	call	restore_regs	; Restore PRL registers
	call	pushshort_r0	; Push size
	move.p5	false, a
	jump	pushobj_a_rplret ; Push false
$777:
	call	restore_regs
	move.p5	true, a
	jump	pushobj_a_rplret ; Push true

	endcode

; Issue error if bad arguments

	rpl
	  If_true_then
	    Error_Bad_Arg_Type

; Create result string in TEMPOB

	  Nullstring, Swap, Realloc
	endrpl

; Copy source strings into result string

	code

	move.a	@d1, a
	move	a, r2		; R2.A = &result
	add	5, d1
	inc.a	d

	call	getshort
	swap.a	a, b		; B.A = N.short
	move	a, r1		; R1.A = saved B

	swap	a, d0
	move	a, r0		; R0.A = saved D0
	move	r2, a
	swap	a, d1		; D1 = &result, A.A = user stack
	move	a, d0		; D0 = user stack
	add	^d10, d1	; D1 = &result data
	dec.a	b
$1000:
	move.a	@d0, c		; C.A = &arg
	swap	c, d0		; D0 = &arg, C.A = saved D0
	push	c		; RSTK = saved D1
	add	5, d0
	move.a	@d0, c		; C.A = size + 5
	add	5, d0		; D0 = &arg data
	sub.a	5, c		; C.A = arg size
	brz.a	c, $1001	; Null string; ignore
	call	blkcopy		; Copy @D0 -> @D1, C.A nybbles
$1001:
	pop	c
	move.a	c, d0		; D0 = user stack

	add	5, d0		; Pop argument
	inc.a	d
	dec.a	b		; One argument less to go
	brcc	$1000		; Loop arguments

	move	r1, c
	move.a	c, b		; Restore B
	move	r0, a
	swap	a, d0		; D0 = saved D0. A.A = user stack
	move	a, d1		; D1 = user stack

	move	r2, a		; A.A = &result
	jump	pushobj_a_rplret ; Push result and continue

	endcode

; Finished

	rpl
	  EndObj
	endrpl
